<template>
  <div>

    <div class="row">
      <div class="form-group col-md-4">
          <label for="">Tahapan Inovasi</label>
          <b-form-select name="tahapanInovasi" class="form-select"
          :options="tahapanInovasi" 
          v-model="selectedTahapanInovasi"
          @change="getFilter()" 
          ></b-form-select>
      </div>
      <div class="form-group col-md-4">
          <label for="">Inisiator Inovasi</label>
          <b-form-select name="inisiatorInovasi" class="form-select"
          :options="inisiatorInovasi" 
          v-model="selectedInisiatorInovasi"
          @change="getFilter()" 
          ></b-form-select>
      </div>
      <div class="form-group col-md-4">
          <label for="">Sistem Inovasi</label>
          <b-form-select name="sistemInovasi" class="form-select"
          :options="sistemInovasi" 
          v-model="selectedSistemInovasi"
          @change="getFilter()" 
          ></b-form-select>
      </div>
<!--       <div class="form-group col-md-4">
        <label for="">Kategori Inovator</label>
        <b-form-select name="kategoriInovator" class="form-select"
        :options="kategoriInovator" 
        v-model="selectedKategoriInovator"
        @change="getFilter()"
        ></b-form-select>
      </div> -->

    <!--   <div class="form-group col-md-4">
        <label for="">Jenis Inovator</label>
        <b-form-select name="jenisInovator" class="form-select"
        :options="jenisInovator" 
        v-model="selectedJenisInovator"
        @change="getFilter()" 
        ></b-form-select>
      </div>

      -->
    </div>

    <div class="filter-more" v-if="!isHidden">
      <div class="row">
        <div class="form-group col-md-4">
          <label for="">Bentuk Inovasi</label>
          <b-form-select name="bentukInovasi" class="form-select"
          :options="bentukInovasi" 
          v-model="selectedBentukInovasi"
          @change="getFilter()" 
          ></b-form-select>
        </div>
        <div class="form-group col-md-4">
          <label for="">Jenis Inovasi</label>
          <b-form-select name="jenisInovasi" class="form-select"
          :options="jenisInovasi" 
          v-model="selectedJenisInovasi"
          @change="getFilter()" 
          ></b-form-select>
        </div>

         <div class="form-group col-md-4">
          <label for="">Covid-19 Inovasi</label>
          <b-form-select name="covidInovasi" class="form-select"
          :options="covidInovasi" 
          v-model="selectedCovidInovasi"
          @change="getFilter()" 
          ></b-form-select>
        </div>

        <div class="form-group col-md-4">
          <label for="">Bidang Inovasi</label>
          <b-form-select name="bidangInovasi" class="form-select"
          :options="bidangInovasi" 
          v-model="selectedBidangInovasi"
          @change="getFilter()" 
          ></b-form-select>
        </div>


      </div>

      <div class="row">


       


      </div>
    </div>

    <div class="btn-filter">
      <button v-on:click="isHidden = !isHidden" class="btn btn-info">Filter More</button>
      <button @click="reset" class="btn btn-danger">Reset</button>
    </div>
    
    <GmapMap
      :center="center"
      :zoom="12"
      map-type-id="roadmap"
      style="width: 100%; height: 500px"
      >
          <GmapMarker
            :key="index"
            v-for="(m, index) in markers"
            :position="m"
            :clickable="true"
            @click="toggleInfo(m, index)"
            :icon="{ url: require('../assets/img/logo.png')}"
          >

          </GmapMarker>
          <!-- <GmapPolygon :paths="paths">
          </GmapPolygon> -->

          <gmap-info-window
          :options="infoOptions"
          :position="infoPosition"
          :opened="infoOpened"
          :content="infoContent"
          @closeclick="infoOpened=false">
          </gmap-info-window>

    </GmapMap>

</div>
</template>

<script>
export default {
  // props: ['inovator'],
  name: "GoogleMap",
  data() {
    return {

      inovator:[],

      selectedKategoriInovator:'',
      selectedJenisInovator:'',
      selectedJenisInovasi:'',
      selectedBentukInovasi:'',
      selectedBidangInovasi:'',
      selectedSistemInovasi:'',
      selectedTahapanInovasi:'',
      selectedCovidInovasi:'',
      selectedInisiatorInovasi:'',
      paths: [
            [ 
              {lat: -8.68129124387479, lng: 115.16345057146378}, 
              {lat:-8.685703279818611, lng: 115.21357569272905},  
              {lat: -8.67484279034151, lng: 115.19520792569007}, 
              {lat: -8.653629991352402, lng: 115.21803888845817} 
            ]
      ],

      isHidden: true,
      center: {
        lat: -8.650000,
        lng: 115.216667
      },
      markers: [],
      currentPlace: null,

      selectedKategoriInovator: null,
      kategoriInovator:
      [
        {value: null, text: 'Pilih Kategori Inovator'},
        {value: 1, text:'OPD'},
        {value: 2, text:'NON OPD'},
      ],
      selectedJenisInovator: null,
      jenisInovator:
      [
        {value: null, text: 'Pilih Jenis Inovator'},
        {value: 1, text:'Perorangan'},
        {value: 2, text:'Komunitas'},
        {value: 3, text:'Pelajar'},
        {value: 4, text:'Mahasiswa'},
        {value: 5, text:'Akademisi'},
        {value: 6, text:'Lembaga'},
        {value: 7, text:'Organisasi Perangkat Daerah'},
      ],
      selectedJenisInovasi: null,
      jenisInovasi:
      [
        {value: null, text: 'Pilih Jenis Inovasi'},
        {value: 2, text:'Produk'},
        {value: 3, text:'Pelayanan'},
        {value: 4, text:'Proses'},
      ],
      selectedBentukInovasi: null,
      bentukInovasi:
      [
        {value: null, text: 'Pilih Bentuk Inovasi'},
        {value: 2, text:'Publik'},
        {value: 3, text:'Pemda'},
        {value: 4, text:'Lainnya'},
      ],
      selectedBidangInovasi: null,
      bidangInovasi:
      [
        {value: null, text: 'Pilih Bidang Inovasi'},
        {value: 2, text:'Pangan'},
        {value: 3, text:'Hankam'},
        {value: 4, text:'Manufaktur'},
        {value: 5, text:'Material Maju'},
        {value: 6, text:'Kesehatan & Obat'},
        {value: 7, text:'Teknologi Informasi'},
        {value: 8, text:'Energi & SDMineral'},
        {value: 9, text:'Transportasi'},
      ],
      selectedSistemInovasi: null,
      sistemInovasi:
      [
        {value: null, text: 'Pilih Sistem Inovasi'},
        {value: 2, text:'Digital'},
        {value: 3, text:'Non Digital'},
      ],
      selectedTahapanInovasi: null,
      tahapanInovasi:
      [
        {value: null, text: 'Pilih Tahapan Inovasi'},
        {value: 2, text:'Inisiatif'},
        {value: 3, text:'Uji Coba'},
        {value: 4, text:'Penerapan'},
      ],
      selectedCovidInovasi: null,
      covidInovasi:
      [
        {value: null, text: 'Pilih Covid-19 Inovasi'},
        {value: 2, text:'Covid-19'},
        {value: 3, text:'Non Covid-19'},
      ],
      selectedInisiatorInovasi: null,
      inisiatorInovasi:
      [
        {value: null, text: 'Pilih Inisiator Inovasi'},
        {value: 2, text:'Kepala Daerah'},
        {value: 3, text:'Anggota DPRD'},
        {value: 4, text:'OPD'},
        {value: 5, text:'ASN'},
        {value: 6, text:'Masyarakat'},
      ],
      infoPosition: null,
      infoContent: null,
      infoOpened: false,
      infoCurrentKey: null,
      infoOptions:{},
      infoOptions: {
        pixelOffset: {
          width: 0,
          height: -35
        },
        content: null
      },

    }
  },

  mounted() {
    this.getInovators();
    this.geolocate();
  },

  // computed: {
  //       filterInovator:{ 
  //           get:function () {
  //               return this.inovator
  //           },
  //           set: function(newValue){
  //               this.$emit('update:value', newValue);
  //           }
  //       }
  //   },

  methods: {

    toggleInfo(m,index){
      this.center = m
      this.infoPosition = m
      this.infoOptions.content= this.showModalInfo(index)
      this.infoOpened = true
    },

    showModalInfo(index){
      let data = this.inovator[index],
          inovasi = data.innovation;
          let judul = [];
          $.each(inovasi, function(key, value){
              judul[key]=value.nama_lengkap+''
          })
      return `<div id="content">
      <div id="siteNotice">
        </div>
          <h5 id="firstHeading" class="firstHeading">Profil Inovasi</h5>
            <div class="table-responsive">
                            <table class="table">
                                <thead>
                                    <tr>
                                        <th width="20%"></th>
                                        <th></th>
                                    </tr>
                                </thead>
                                <tbody>
                                  <tr>
                                    <td>Nama Inovasi</td>
                                    <td>: ${judul} </td>
                                  </tr>
                                  <tr>
                                    <td>Nama Akun</td>
                                    <td>: ${data.nama} </td>
                                  </tr>
                                  <tr>
                                    <td>Alamat</td>
                                    <td>: ${data.jalan}, ${data.desa}, ${data.kecamatan} <br>
                                          ${data.kota}, ${data.provinsi} 
                                    </td>
                                  </tr>
                                </tbody>
                            </table>
                        </div>
          </div>
      </div>`
    },

    getInovators(){
        axios.get('map/list').then((response)=>{
        // console.log(response)
        this.inovator = response.data
        this.setMarker()
      })
      },

    setPlace(place) {
      this.currentPlace = place;
    },

    geolocate: function() {
      navigator.geolocation.getCurrentPosition(position => {
        this.center = {
          lat: position.coords.latitude,
          lng: position.coords.longitude
        };
      });
      this.setMarker();
    },
    setMarker(){
      let data = this.inovator;
      let mark=[];
      $.each(data, function(key, value) {
       let ket = JSON.parse(value.map)
       mark[key] = ket
     });
      this.markers = mark;
    },

    getFilter(){
      let data = {
        kategoriInovator:this.selectedKategoriInovator,
        jenisInovator:this.selectedJenisInovator,
        jenisInovasi:this.selectedJenisInovasi,
        bentukInovasi:this.selectedBentukInovasi,
        bidangInovasi:this.selectedBidangInovasi,
        sistemInovasi:this.selectedSistemInovasi,
        tahapanInovasi:this.selectedTahapanInovasi,
        covidInovasi:this.selectedCovidInovasi,
        inisiatorInovasi:this.selectedInisiatorInovasi,
      }
      this.postData(data)
    },

    postData(data){
      let url = 'map/filter'
      let formData = this.formData(data)
      // console.log(formData)
      axios.post(url,formData).then((response) =>{
        this.inovator = response.data
        // console.log(this.inovator)
        this.setMarker()
      })
      .catch(function(error) {
          // console.error(error);
      });
    },
    formData(obj){
      var formData = new FormData();
      for (var key in obj) {
          formData.append(key, obj[key]);
      }
      return formData;
    },

    reset(){
      this.selectedKategoriInovator=null,
      this.selectedJenisInovator=null,
      this.selectedJenisInovasi=null,
      this.selectedBentukInovasi=null,
      this.selectedBidangInovasi=null,
      this.selectedSistemInovasi=null,
      this.selectedTahapanInovasi=null,
      this.selectedCovidInovasi=null,
      this.selectedInisiatorInovasi=null,

      this.getInovators()
    }

  }
};
</script>
<style>
.btn-filter{
  margin-bottom: 10px;
}
table th {
  display: none;
}
</style>